cryo_agent/publisher/routes/settings.py
import logging

from flask import Blueprint, redirect, render_template, request, url_for
from sqlalchemy.orm import Session

from cryo_agent.logic.settings import (
    get_cryo_agent_settings,
    get_web_settings,
    write_cryo_agent_settings,
    write_web_settings,
)
from cryo_agent.publisher import tasks
from cryo_agent.publisher.db import get_engine

LOGGER = logging.getLogger(__name__)

bp = Blueprint("settings", __name__, url_prefix="/settings")


@bp.route("/")
def index():
    with Session(get_engine()) as session:
        return render_template(
            "settings/index.html",
            cryo_agent_settings=get_cryo_agent_settings(session),
            web_settings=get_web_settings(session),
        )


@bp.route("/update_cryo_agent_settings/", methods=["POST"])
def update_cryo_agent_settings():
    with Session(get_engine()) as session:
        changed_items = write_cryo_agent_settings(session, **request.form)

        if "log_level" in changed_items:
            tasks.update_cryo_agent_log_level(changed_items["log_level"])

    return redirect(url_for("settings.index", _anchor="cryo_agent_settings"))


@bp.route("/update_web_settings/", methods=["POST"])
def update_web_settings():
    with Session(get_engine()) as session:
        changed_items = write_web_settings(session, **request.form)

        if "log_level" in changed_items:
            tasks.update_web_log_level(changed_items["log_level"])

    return redirect(url_for("settings.index", _anchor="web_settings"))

cryo_agent/publisher/templates/settings/components/base.html
<section id="cryo_agent_settings">
    <form action="{{ url_for('settings.update_cryo_agent_settings') }}"
          method="post">
        <div class="settings-tab">
            <div class="settings-tab-data">
                <h2>General Settings</h2>
                <table class="settings-table">
                    <tr>
                        <td class="settings-label tooltip">
                            <label for="fridge_name">Fridge name</label>
                            <span class="tooltiptext">Unique name of the fridge</span>
                        </td>
                        <td class="settings-data">
                            <input class="settings-text-input"
                                   disabled
                                   type="text"
                                   id="fridge_name"
                                   name="fridge_name"
                                   value="{{ cryo_agent_settings.fridge_name }}">
                        </td>
                    </tr>
                    <tr>
                        <td class="settings-label tooltip">
                            <label for="log_level">Log level</label>
                            <span class="tooltiptext">Log level of the main process</span>
                        </td>
                        <td class="settings-data">
                            <select name="log_level" id="log_level">
                                <option {% if cryo_agent_settings.log_level=="DEBUG" %}selected="selected"{% endif %}>DEBUG</option>
                                <option {% if cryo_agent_settings.log_level=="INFO" %}selected="selected"{% endif %}>INFO</option>
                                <option {% if cryo_agent_settings.log_level=="WARNING" %}selected="selected"{% endif %}>WARNING</option>
                                <option {% if cryo_agent_settings.log_level=="ERROR" %}selected="selected"{% endif %}>ERROR</option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td class="settings-label tooltip">
                            <label for="alert_settings_upload_method">Alert settings upload method</label>
                            <span class="tooltiptext">Upload method for updating/settings the alert settings</span>
                        </td>
                        <td class="settings-data">
                            <select name="alert_settings_upload_method" id="alert_settings_upload_method">
                                <option {% if cryo_agent_settings.alert_settings_upload_method=="API" %}selected="selected"{% endif %}>API</option>
                                <option {% if cryo_agent_settings.alert_settings_upload_method=="File" %}selected="selected"{% endif %}>File</option>
                            </select>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="settings-tab-save">
                <button class="button-3" type="submit">Save settings</button>
            </div>
        </div>
    </form>
</section>
<script>
//$(() =>{
//    $("#log_level").selectmenu({
//        change: function(event, data){
//            console.log('test')
//        }
//    });
//});
</script>

cryo_agent/publisher/templates/settings/components/web.html
<section id="web_settings">
    <form action="{{ url_for('settings.update_web_settings') }}" method="post">
        <div class="settings-tab">
            <div class="settings-tab-data">
                <h2>Web Settings</h2>
                <table class="settings-table">
                    <tr>
                        <td class="settings-label tooltip">
                            <label for="port">Port</label>
                            <span class="tooltiptext">Port on which the application is run</span>
                        </td>
                        <td class="settings-data">
                            <input class="settings-text-input"
                                   disabled
                                   type="text"
                                   id="port"
                                   name="port"
                                   value="{{ web_settings.port }}">
                        </td>
                    </tr>
                    <tr>
                        <td class="settings-label tooltip">
                            <label for="log_level">Log level</label>
                            <span class="tooltiptext">Log level of the web process</span>
                        </td>
                        <td class="settings-data">
                            <select name="log_level" id="log_level">
                                <option {% if web_settings.log_level=="DEBUG" %}selected="selected"{% endif %}>DEBUG</option>
                                <option {% if web_settings.log_level=="INFO" %}selected="selected"{% endif %}>INFO</option>
                                <option {% if web_settings.log_level=="WARNING" %}selected="selected"{% endif %}>WARNING</option>
                                <option {% if web_settings.log_level=="ERROR" %}selected="selected"{% endif %}>ERROR</option>
                            </select>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="settings-tab-save">
                <button class="button-3" type="submit">Save settings</button>
            </div>
        </div>
    </form>
</section>